// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acFileStorage.pas' rev: 5.00

#ifndef acFileStorageHPP
#define acFileStorageHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <acClasses.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Acfilestorage
{
//-- type declarations -------------------------------------------------------
typedef TacObjectList TStoredFiles;
;

class DELPHICLASS TStoredFile;
class PASCALIMPLEMENTATION TStoredFile : public Acclasses::TacAddon 
{
	typedef Acclasses::TacAddon inherited;
	
private:
	AnsiString FFileName;
	unsigned FSize;
	Classes::TMemoryStream* FData;
	virtual bool __fastcall Extract(const AnsiString FileName, bool CreatePath);
	
public:
	__fastcall virtual TStoredFile(Classes::TComponent* aOwner);
	__fastcall virtual ~TStoredFile(void);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	bool __fastcall Upload(const AnsiString FileName);
	void __fastcall ClearData(void);
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property unsigned Size = {read=FSize, write=FSize, nodefault};
	__property Classes::TMemoryStream* Data = {read=FData, write=FData};
};


#pragma option push -b-
enum TacFileStorageOverwrite { owIfSizeDifferent, owNever, owAlways };
#pragma option pop

class DELPHICLASS TExtractTo;
class PASCALIMPLEMENTATION TExtractTo : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FCreatePath;
	Acclasses::TacSystemDirectory FToplevelDir;
	AnsiString FSubdirectory;
	
public:
	AnsiString __fastcall Path();
	
__published:
	__property bool CreatePath = {read=FCreatePath, write=FCreatePath, default=1};
	__property Acclasses::TacSystemDirectory ToplevelDir = {read=FToplevelDir, write=FToplevelDir, default=0
		};
	__property AnsiString Subdirectory = {read=FSubdirectory, write=FSubdirectory};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TExtractTo(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TExtractTo(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TAutoExtract;
class PASCALIMPLEMENTATION TAutoExtract : public Acclasses::TacAddon 
{
	typedef Acclasses::TacAddon inherited;
	
private:
	TExtractTo* FExtractTo;
	TacFileStorageOverwrite FOverwrite;
	bool FRemoveOnTerminate;
	
public:
	__fastcall virtual TAutoExtract(Classes::TComponent* aOwner);
	__fastcall virtual ~TAutoExtract(void);
	
__published:
	__property TExtractTo* ExtractTo = {read=FExtractTo, write=FExtractTo};
	__property TacFileStorageOverwrite Overwrite = {read=FOverwrite, write=FOverwrite, default=0};
	__property bool RemoveOnTerminate = {read=FRemoveOnTerminate, write=FRemoveOnTerminate, default=0};
		
};


typedef void __fastcall (__closure *TOnExtractEvent)(System::TObject* Sender, AnsiString FileName, int 
	FileSize, bool &AllowExtracting);

typedef void __fastcall (__closure *TOnExtractedEvent)(System::TObject* Sender, AnsiString FileName, 
	int FileSize, bool Successfully);

class DELPHICLASS TacFileStorage;
class PASCALIMPLEMENTATION TacFileStorage : public Acclasses::TacComponent 
{
	typedef Acclasses::TacComponent inherited;
	
private:
	TAutoExtract* FAutoExtract;
	Acclasses::TacObjectList* FFiles;
	Classes::TStringList* ExtractedFilesList;
	TOnExtractEvent FOnExtract;
	TOnExtractedEvent FOnExtracted;
	bool Compressed;
	unsigned __fastcall GetDataSize(void);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	unsigned FCount;
	__fastcall virtual TacFileStorage(Classes::TComponent* aOwner);
	__fastcall virtual ~TacFileStorage(void);
	bool __fastcall Extract(const AnsiString FileName, AnsiString OutputFile)/* overload */;
	bool __fastcall Extract(int FileIndex, AnsiString OutputFile)/* overload */;
	
__published:
	__property TAutoExtract* AutoExtract = {read=FAutoExtract, write=FAutoExtract};
	__property unsigned Count = {read=FCount, write=SetNoneLong, stored=false, nodefault};
	__property unsigned DataSize = {read=GetDataSize, write=SetNoneLong, stored=false, nodefault};
	__property Acclasses::TacObjectList* Files = {read=FFiles, write=FFiles, stored=false};
	__property TOnExtractEvent OnExtract = {read=FOnExtract, write=FOnExtract};
	__property TOnExtractedEvent OnExtracted = {read=FOnExtracted, write=FOnExtracted};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Acfilestorage */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Acfilestorage;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// acFileStorage
