// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acSendMail.pas' rev: 5.00

#ifndef acSendMailHPP
#define acSendMailHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <acThread.hpp>	// Pascal unit
#include <acTextTemplateConverter.hpp>	// Pascal unit
#include <acInet.hpp>	// Pascal unit
#include <acClasses.hpp>	// Pascal unit
#include <WinSock.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Acsendmail
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TacSMTPPriority { mpHighest, mpHigh, mpNormal, mpLow, mpLowest };
#pragma option pop

#pragma option push -b-
enum TacSMTPAttachType { atNormal, atEmbedded };
#pragma option pop

#pragma option push -b-
enum TacSMTPContentType { ctPlainText, ctHTML };
#pragma option pop

typedef void __fastcall (__closure *TacSMTPCantAttachEvent)(System::TObject* Sender, const AnsiString 
	FileName);

typedef void __fastcall (__closure *TacSMTPProgressEvent)(System::TObject* Sender, int MessageSize, 
	int BytesSent, Byte PercentsDone);

typedef void __fastcall (__closure *TacSMTPResponseEvent)(System::TObject* Sender, int Code, const AnsiString 
	Response);

class DELPHICLASS TacSMTPData;
class PASCALIMPLEMENTATION TacSMTPData : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Acinet::TacSocketHelper* SockHelper;
	Classes::TMemoryStream* Stream;
	int ResponseCode;
	AnsiString ResponseStr;
	
public:
	__fastcall TacSMTPData(void);
	__fastcall virtual ~TacSMTPData(void);
};


class DELPHICLASS TSendMailAuthentication;
class PASCALIMPLEMENTATION TSendMailAuthentication : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	AnsiString FUsername;
	AnsiString FPassword;
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property AnsiString Username = {read=FUsername, write=FUsername};
	__property AnsiString Password = {read=FPassword, write=FPassword};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSendMailAuthentication(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSendMailAuthentication(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TacSendMail;
class PASCALIMPLEMENTATION TacSendMail : public Acclasses::TacComponent 
{
	typedef Acclasses::TacComponent inherited;
	
private:
	TSendMailAuthentication* FAuthentication;
	AnsiString FSMTPHost;
	int FSMTPPort;
	TacSMTPContentType FMsgContentType;
	AnsiString FMsgContentCharset;
	AnsiString FMsgSubject;
	AnsiString FMsgBody;
	System::TDateTime FMsgDateTime;
	TacSMTPPriority FMsgPriority;
	Actexttemplateconverter::TacTextTemplateConverter* FTemplateConverter;
	bool FThreaded;
	AnsiString FAgent;
	AnsiString FFromAddress;
	AnsiString FFromName;
	AnsiString FFromOrganization;
	AnsiString FTo;
	AnsiString FToCC;
	AnsiString FToBCC;
	AnsiString FReplyTo;
	Classes::TStrings* FAddHeaders;
	Classes::TStrings* FAttach;
	TacSMTPAttachType FAttachType;
	Classes::TThreadPriority FThreadPriority;
	bool FWaitThread;
	int FWaitTimeout;
	TacSMTPProgressEvent FOnProgress;
	TacSMTPResponseEvent FOnResponse;
	Classes::TNotifyEvent FOnSuccess;
	Classes::TNotifyEvent FOnAborted;
	Classes::TNotifyEvent FOnAnyError;
	TacSMTPCantAttachEvent FOnCantAttach;
	Classes::TNotifyEvent FOnConnLost;
	Classes::TNotifyEvent FOnHostUnreachable;
	TacSMTPResponseEvent FOnSMTPError;
	Acthread::TacThreadWaitTimeoutExpired FOnWaitTimeoutExpired;
	bool FBusy;
	bool FRealBusy;
	Acthread::TacCustomThread* FThread;
	TacSMTPData* FActiveSMTPData;
	int CantAttachFileIndex;
	void __fastcall SetAddHeaders(Classes::TStrings* Value);
	void __fastcall SetAttach(Classes::TStrings* Value);
	void __fastcall SetTemplateConverter(Actexttemplateconverter::TacTextTemplateConverter* Value);
	bool __fastcall GetThreadBusy(void);
	bool __fastcall IsNotLocalHost(void);
	bool __fastcall IsNotDefaultContentCharset(void);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* aComponent, Classes::TOperation aOperation
		);
	void __fastcall ProduceMessage(const Classes::TStream* Stream, bool ToFile, bool Unsent);
	void __fastcall SendMessage(void);
	void __fastcall ReleaseSMTPStream(void);
	void __fastcall ThreadExecute(System::TObject* Sender);
	void __fastcall ThreadException(System::TObject* Sender);
	void __fastcall ThreadTerminate(System::TObject* Sender);
	void __fastcall ThreadWaitTimeoutExpired(System::TObject* Sender, bool &TerminateThread);
	void __fastcall DoHostUnreachable(void);
	void __fastcall DoSuccess(void);
	void __fastcall DoSMTPResponse(int ResponseCode, const AnsiString ResponseStr);
	void __fastcall DoSMTPError(int ErrorCode, const AnsiString ErrorStr);
	void __fastcall DoProgress(Classes::TMemoryStream* Stream);
	void __fastcall DoConnLost(void);
	void __fastcall SyncCantAttach(void);
	void __fastcall SyncHostUnreachable(void);
	void __fastcall SyncSuccess(void);
	void __fastcall SyncSMTPResponse(void);
	void __fastcall SyncSMTPError(void);
	void __fastcall SyncProgress(void);
	void __fastcall SyncConnLost(void);
	
public:
	__fastcall virtual TacSendMail(Classes::TComponent* aOwner);
	__fastcall virtual ~TacSendMail(void);
	bool __fastcall Send(void);
	bool __fastcall SaveToFile(const AnsiString FileName, bool Unsent);
	void __fastcall Abort(bool HardTerminate);
	__property bool Busy = {read=FBusy, nodefault};
	__property bool ThreadBusy = {read=GetThreadBusy, nodefault};
	__property Acthread::TacCustomThread* Thread = {read=FThread};
	
__published:
	__property TSendMailAuthentication* Authentication = {read=FAuthentication, write=FAuthentication};
		
	__property AnsiString SMTPHost = {read=FSMTPHost, write=FSMTPHost, stored=IsNotLocalHost};
	__property int SMTPPort = {read=FSMTPPort, write=FSMTPPort, default=25};
	__property AnsiString MsgContentCharset = {read=FMsgContentCharset, write=FMsgContentCharset, stored=
		IsNotDefaultContentCharset};
	__property TacSMTPContentType MsgContentType = {read=FMsgContentType, write=FMsgContentType, default=0
		};
	__property System::TDateTime MsgDateTime = {read=FMsgDateTime, write=FMsgDateTime};
	__property AnsiString MsgSubject = {read=FMsgSubject, write=FMsgSubject};
	__property AnsiString MsgBody = {read=FMsgBody, write=FMsgBody};
	__property TacSMTPPriority MsgPriority = {read=FMsgPriority, write=FMsgPriority, default=2};
	__property AnsiString Agent = {read=FAgent, write=FAgent};
	__property Classes::TStrings* AddHeaders = {read=FAddHeaders, write=SetAddHeaders};
	__property Classes::TStrings* Attach = {read=FAttach, write=SetAttach};
	__property TacSMTPAttachType AttachType = {read=FAttachType, write=FAttachType, default=0};
	__property AnsiString FromAddress = {read=FFromAddress, write=FFromAddress};
	__property AnsiString FromName = {read=FFromName, write=FFromName};
	__property AnsiString FromOrganization = {read=FFromOrganization, write=FFromOrganization};
	__property AnsiString ToAddr = {read=FTo, write=FTo};
	__property AnsiString ToCC = {read=FToCC, write=FToCC};
	__property AnsiString ToBCC = {read=FToBCC, write=FToBCC};
	__property AnsiString ReplyTo = {read=FReplyTo, write=FReplyTo};
	__property Actexttemplateconverter::TacTextTemplateConverter* TemplateConverter = {read=FTemplateConverter
		, write=SetTemplateConverter};
	__property bool Threaded = {read=FThreaded, write=FThreaded, default=1};
	__property Classes::TThreadPriority ThreadPriority = {read=FThreadPriority, write=FThreadPriority, 
		default=3};
	__property bool WaitThread = {read=FWaitThread, write=FWaitThread, default=0};
	__property int WaitTimeout = {read=FWaitTimeout, write=FWaitTimeout, default=0};
	__property TacSMTPProgressEvent OnProgress = {read=FOnProgress, write=FOnProgress};
	__property TacSMTPResponseEvent OnResponse = {read=FOnResponse, write=FOnResponse};
	__property Classes::TNotifyEvent OnSuccess = {read=FOnSuccess, write=FOnSuccess};
	__property Classes::TNotifyEvent OnAborted = {read=FOnAborted, write=FOnAborted};
	__property Classes::TNotifyEvent OnAnyError = {read=FOnAnyError, write=FOnAnyError};
	__property TacSMTPCantAttachEvent OnCantAttach = {read=FOnCantAttach, write=FOnCantAttach};
	__property Classes::TNotifyEvent OnConnLost = {read=FOnConnLost, write=FOnConnLost};
	__property Classes::TNotifyEvent OnHostUnreachable = {read=FOnHostUnreachable, write=FOnHostUnreachable
		};
	__property TacSMTPResponseEvent OnSMTPError = {read=FOnSMTPError, write=FOnSMTPError};
	__property Acthread::TacThreadWaitTimeoutExpired OnWaitTimeoutExpired = {read=FOnWaitTimeoutExpired
		, write=FOnWaitTimeoutExpired};
};


class DELPHICLASS TacCustomSendMailProperties;
class PASCALIMPLEMENTATION TacCustomSendMailProperties : public Acclasses::TacPersistent 
{
	typedef Acclasses::TacPersistent inherited;
	
private:
	AnsiString FMsgContentCharset;
	AnsiString FMsgFromAddress;
	AnsiString FMsgFromName;
	AnsiString FMsgToAddress;
	AnsiString FMsgToName;
	AnsiString FMsgSubject;
	TacSMTPPriority FMsgPriority;
	AnsiString FSMTPHost;
	Word FSMTPPort;
	bool FThreaded;
	bool __fastcall IsNotDefaultContentCharset(void);
	bool __fastcall IsNotLocalHost(void);
	
public:
	__fastcall virtual TacCustomSendMailProperties(Classes::TComponent* aOwner);
	__property AnsiString MsgContentCharset = {read=FMsgContentCharset, write=FMsgContentCharset, stored=
		IsNotDefaultContentCharset};
	__property AnsiString MsgFromAddress = {read=FMsgFromAddress, write=FMsgFromAddress};
	__property AnsiString MsgFromName = {read=FMsgFromName, write=FMsgFromName};
	__property AnsiString MsgToAddress = {read=FMsgToAddress, write=FMsgToAddress};
	__property AnsiString MsgToName = {read=FMsgToName, write=FMsgToName};
	__property AnsiString MsgSubject = {read=FMsgSubject, write=FMsgSubject};
	__property TacSMTPPriority MsgPriority = {read=FMsgPriority, write=FMsgPriority, default=2};
	__property AnsiString SMTPHost = {read=FSMTPHost, write=FSMTPHost, stored=IsNotLocalHost};
	__property Word SMTPPort = {read=FSMTPPort, write=FSMTPPort, default=25};
	__property bool Threaded = {read=FThreaded, write=FThreaded, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacCustomSendMailProperties(void) { }
	#pragma option pop
	
};


class DELPHICLASS TacSendMailProperties;
class PASCALIMPLEMENTATION TacSendMailProperties : public TacCustomSendMailProperties 
{
	typedef TacCustomSendMailProperties inherited;
	
__published:
	__property MsgContentCharset ;
	__property MsgFromAddress ;
	__property MsgFromName ;
	__property MsgToAddress ;
	__property MsgToName ;
	__property MsgSubject ;
	__property MsgPriority ;
	__property SMTPHost ;
	__property SMTPPort ;
	__property Threaded ;
public:
	#pragma option push -w-inl
	/* TacCustomSendMailProperties.Create */ inline __fastcall virtual TacSendMailProperties(Classes::TComponent* 
		aOwner) : TacCustomSendMailProperties(aOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacSendMailProperties(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE bool __fastcall SendMail(const AnsiString FromAddr, const AnsiString FromName, const 
	AnsiString ToAddr, const AnsiString ToName, const AnsiString Subject, const AnsiString Body, const 
	AnsiString SMTPHost, Word SMTPPort, TacSMTPContentType ContentType, TacSMTPPriority Priority, const 
	AnsiString ContentCharset, bool RunInSeparateThread);

}	/* namespace Acsendmail */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Acsendmail;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// acSendMail
